unit Procs;

interface

uses Graphics, Defs;

function FindParam(Param: String): Boolean;
procedure Error(Message: String);
procedure LoadSound(FileName: String; Size: Word);
function  CheckMove(x, y: Integer; dx, dy: Integer): Byte;
procedure LoadFont(Size: Byte; FileName: String);

type
    PLevel = ^TLevel;
    TLevel = array[1..LEVEL_WIDTH div 20, 1..LEVEL_HEIGHT div 14] of Byte;

var Data: Pointer;
    Level: PLevel;
    Sound: Pointer;

implementation

procedure LoadFont(Size: Byte; FileName: String);
  var f: File;
begin
  FontSize := Size;

  {$I-}
  Assign(f, FileName);
  Reset(f, 256);
  {$I+}

  if IOResult <> 0 then
    Error(ERROR_3);

  GetMem(Font, Size * 256);
  BlockRead(f, Font^, Size);

  Close(f);
end;

function FindParam(Param: String): Boolean;
  var i: Integer;

  function UpStr(S: String): String;
    var j: Integer;
  begin
    for j := 1 to Length(S) do
      S[j] := UpCase(S[j]);
    UpStr := S;
  end;

begin
  FindParam := False;

  for i := 1 to ParamCount do
    if UpStr(ParamStr(i)) = Param then FindParam := True;
end;

procedure Error(Message: String);
begin
  SetMode(3);
  Writeln(Message);
  asm
    mov ax, 4CFFh
    int 21h
  end;
end;

procedure LoadSound(FileName: String; Size: Word);
  var f: File;
begin
  GetMem(Sound, Size);
  Assign(f, FileName);
  Reset(f, 1);
  BlockRead(f, Sound^, Size);
  Close(f);
end;

function  CheckMove(x, y: Integer; dx, dy: Integer): Byte;
  var Px, Py, i, j, n: Integer;
begin
  for i := (x - dx) div 20 - 1 to (x - dx) div 20 + 1 do
  for j := (y - dy) div 14 - 1 to (y - dy) div 14 + 1 do begin
    Px := i * 20;
    Py := j * 14;
    if (x > Px - 18) and (x < Px + 18) and (y > Py - 14) and (y < Py + 18) then
      n := Level^[i + 1, j + 1];
  end;
  CheckMove := n;
end;

end.
