{**********************************************************************}
{*                                                                    *}
{*        SB.PAS -                                                    *}
{*        Copyright (c) MATI Inc. 1998.                               *}
{*                                                                    *}
{**********************************************************************}
unit SB;

interface

const BASE = $220;
const DSP_RESET = BASE + $06;
const DSP_READ_DATA = BASE + $0A;
const DSP_WRITE_DATA = BASE + $0C;
const DSP_WRITE_STATUS = BASE + $0C;
const DSP_DATA_AVAIL = BASE + $0E;

procedure WriteDSP(Value: Byte);
function ReadDSP: Byte;
function ResetDSP: Boolean;
procedure WriteDAC(Level: Byte);
function ReadDAC: Byte;
function SpeakerOn: Byte;
function SpeakerOff: Byte;
procedure DMAStop;
procedure DMAContinue;
procedure Playback(Sound: Pointer; Size: Word; Frequency: Word);

implementation

uses Crt;

procedure WriteDSP(Value: Byte);
begin
  while Port[DSP_WRITE_STATUS] and $80 <> 0 do;
  Port[DSP_WRITE_DATA] := Value;
end;

function ReadDSP: Byte;
begin
  while Port[DSP_WRITE_STATUS] and $80 <> 0 do;
  ReadDSP := Port[DSP_READ_DATA];
end;

function ResetDSP: Boolean;
begin
  Port[DSP_RESET] := 1; Delay(10);
  Port[DSP_RESET] := 0; Delay(10);
  if (Port[DSP_DATA_AVAIL] and $80 = $80) and
    (Port[DSP_READ_DATA] = $AA) then
      ResetDSP := True
    else
      ResetDSP := False;
end;

procedure WriteDAC(Level: Byte);
begin

end;

function ReadDAC: Byte;
begin

end;

function SpeakerOn: Byte;
begin
  WriteDSP($D1);
end;

function SpeakerOff: Byte;
begin
  WriteDSP($D3);
end;

procedure DMAStop;
begin
  WriteDSP($D0);
end;

procedure DMAContinue;
begin
  WriteDSP($D4);
end;

procedure Playback(Sound: Pointer; Size: Word; Frequency: Word);
  var TimeConst: Word;
      Page, Offset: Word;
begin
  SpeakerOn;
  Dec(Size);
  Offset := Seg(Sound^) shl 4 + Ofs(Sound^);
  Page := (Seg(Sound^) + Ofs(Sound^) shr 4) shr 12;
  Port[$0A] := 5;
  Port[$0C] := 0;
  Port[$0B] := $49;
  Port[$02] := Lo(Offset);
  Port[$02] := Hi(Offset);
  Port[$83] := Page;
  Port[$03] := Lo(Size);
  Port[$03] := Hi(Size);
  Port[$0A] := 1;
  TimeConst := 256 - 1000000 div Frequency;
  WriteDSP($40);
  WriteDSP(TimeConst);
  WriteDSP($14);
  WriteDSP(Lo(Size));
  WriteDSP(Hi(Size));
end;

end.
